var versionNumber = '1.12';

var US_DATE_FORMAT = "mm/dd/yyyy";
var WORLD_DATE_FORMAT = "dd/mm/yyyy";

var defaultEventDate = '1/1';
var defaultEventName = 'New Year\'s Day';
var defaultCountWeekdaysOnly = false;
var defaultDateFormat = US_DATE_FORMAT;
var eventDate = defaultEventDate;
var eventName = defaultEventName;
var countWeekdaysOnly = defaultCountWeekdaysOnly;
var dateFormat = defaultDateFormat;

var showingFront = true;

var showingFrontCloseBoxX = 75;
var showingFrontCloseBoxY = 96;
var showingBackCloseBoxX = 30;
var showingBackCloseBoxY = 25;

var inUnitedStates = false;

function init() {
	widget.onhide = onhide;
	widget.onshow = onshow;
	widget.onremove = onremove;
	
	// Position the close box.
	widget.setCloseBoxOffset( showingFrontCloseBoxX, showingFrontCloseBoxY );
	
	// If there are pre-saved prefs, load them.
	var eventDateTemp = widget.preferenceForKey( createInstanceSpecificKey( 'eventDate' ) );
	var eventNameTemp = widget.preferenceForKey( createInstanceSpecificKey( 'eventName' ) );
	var countWeekdaysOnlyTemp = widget.preferenceForKey( createInstanceSpecificKey( 'countWeekdaysOnly' ) );
	var dateFormatTemp = widget.preferenceForKey( createInstanceSpecificKey( 'dateFormat' ) );
	
	if ( eventDateTemp ) eventDate = eventDateTemp;
	if ( eventNameTemp ) eventName = eventNameTemp;
	if ( countWeekdaysOnlyTemp ) countWeekdaysOnly = countWeekdaysOnlyTemp;
	if ( dateFormatTemp )
	{
		dateFormat = dateFormatTemp;
	}
	else
	{
		dateFormatTemp = widget.preferenceForKey( createWidgetWideKey( 'dateFormat' ) );
		if ( dateFormatTemp )
		{
			dateFormat = dateFormatTemp;
		}
	}
	
	// Localize the strings in the HTML.
	eventDateLabel.innerText = getLocalizedString( "Event Date" ) + ":";
	eventNameLabel.innerText = getLocalizedString( "Event Name" ) + ":";
	doneButton.value = getLocalizedString( "Done" );
	aboutButton.value = getLocalizedString( "Update" ) + "/" + getLocalizedString( "Donate" );
	countWeekdaysOnlyLabel.innerText = getLocalizedString( "Count Weekdays Only" );
	dateFormatLabel.innerText = getLocalizedString( "Preferred Date Format" ) + ":";
	
	// Load up the date formats.
	var gadget = document.getElementById('dateFormatGadget');
	gadget.options.length = 0;
	gadget.options[0] = new Option( US_DATE_FORMAT, US_DATE_FORMAT, true, (dateFormat==US_DATE_FORMAT) );
	gadget.options[1] = new Option( WORLD_DATE_FORMAT, WORLD_DATE_FORMAT, false, (dateFormat==WORLD_DATE_FORMAT) );
	setDateFormatDirective();
	
	onshow();
	alert( 'inUnitedStates = ' + inUnitedStates );
	if ( window.TimeZoneInfo ) {
		alert( "Yes, it has time zone info!" );
	}
	
	// Animate the date fading in.
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer  = null;
	}

//	var starttime = (new Date).getTime() - 13;
			
//	animation.duration = 500;
//	animation.starttime = starttime;
//	animation.firstElement = document.getElementById ('text');
//	animation.timer = setInterval ("animate();", 13);
//	animation.to = 1.0;
//	animation.from = 0.0;
//	animate();

}

function setDateFormatDirective() {
	document.getElementById( "dateFormatDirective" ).innerText = "(" + dateFormat.substring( 0, 5 ) + " " + getLocalizedString( "or" ) + " " + dateFormat + ")";
}

function onremove() {
	widget.setPreferenceForKey( null, createInstanceSpecificKey( 'eventDate' ) );
	widget.setPreferenceForKey( null, createInstanceSpecificKey( 'eventName' ) );
	widget.setPreferenceForKey( null, createInstanceSpecificKey( 'countWeekdaysOnly' ) );
	widget.setPreferenceForKey( null, createInstanceSpecificKey( 'dateFormat' ) );
	widget.setPreferenceForKey( null, createInstanceSpecificKey( 'widgetVersion' ) );
}

function createInstanceSpecificKey( keyName ) {
	return widget.identifier + '-' + keyName;
}

function createWidgetWideKey( keyName ) {
	return keyName;
}

var timerInterval = null;
function onshow() {
	if ( showingFront )	updateTime();
	if ( timerInterval == null ) {
		timerInterval = setInterval("updateTime();", 60000);
	}
}

function onhide() {
	if ( timerInterval != null ) {
		clearInterval(timerInterval);
		timerInterval = null;
	}
}

function showFront() {
	widget.prepareForTransition('ToFront');
	
	// Position the close box.
	widget.setCloseBoxOffset( showingFrontCloseBoxX, showingFrontCloseBoxY );
	
	// Retrieve the prefs from the form.
	eventDate = document.getElementById( "eventDateField" ).value;
	eventName = document.getElementById( "eventNameField" ).value;
	countWeekdaysOnly = document.getElementById( "countWeekdaysOnlyCheckbox" ).checked;
	dateFormat = document.getElementById( "dateFormatGadget" ).value;
	
	// Save the prefs.
	widget.setPreferenceForKey( eventDate, createInstanceSpecificKey( "eventDate" ) );
	widget.setPreferenceForKey( eventName, createInstanceSpecificKey( "eventName" ) );
	widget.setPreferenceForKey( countWeekdaysOnly, createInstanceSpecificKey( "countWeekdaysOnly" ) );
	widget.setPreferenceForKey( dateFormat, createInstanceSpecificKey( "dateFormat" ) );
	widget.setPreferenceForKey( dateFormat, createWidgetWideKey( "dateFormat" ) );
	widget.setPreferenceForKey( versionNumber, createInstanceSpecificKey( "widgetVersion" ) );
	
	// Set up the UI.
	document.getElementById( "widgetFront" ).style.display = 'block';
	document.getElementById( "widgetBack" ).style.display = 'none';
	updateTime();
	
	// Hide the prefs button.
	document.getElementById( "i" ).style.opacity = 0;
	animation.now = 0.0;
	document.getElementById( "iCircle" ).style.display = 'none';
	flipShown = false;
	
	setTimeout( 'widget.performTransition();', 0 );
	showingFront = true;
}

function showPrefs() {
	widget.prepareForTransition('ToBack');

	// Position the close box.
	widget.setCloseBoxOffset( showingBackCloseBoxX, showingBackCloseBoxY );
	
	document.getElementById( "eventDateField" ).value = eventDate;
	document.getElementById( "eventNameField" ).value = eventName;
	document.getElementById( "dateFormatGadget" ).selectedIndex = ( dateFormat == US_DATE_FORMAT) ? 0 : 1;
	setDateFormatDirective();
	document.getElementById( "countWeekdaysOnlyCheckbox" ).checked = countWeekdaysOnly;

	document.getElementById( "widgetFront" ).style.display = 'none';
	document.getElementById( "widgetBack" ).style.display = 'block';
	
	setTimeout( 'widget.performTransition();', 0 );
	showingFront = false;
}

function updateTime()
{
	var thisEventDate = eventDate;
	var thisEventName = eventName;
	
	// Calculate the time in milliseconds for midnight on that day.
	var now = new Date();
	var nowYear = now.getYear() + 1900;
	var nowMillis = now.valueOf();
	
	var eventDateValues = thisEventDate.split( '/' );
	if ( eventDateValues.length < 2 ) {
		eventDateValues = thisEventDate.split( '-' );
		if ( eventDateValues.length < 2 ) {
			eventDateValues = defaultEventDate.split( '/' );
			thisEventName = defaultEventName;
		}
	}
	var eventMonth;
	var eventDay;
	if ( dateFormat == US_DATE_FORMAT )
	{
		eventMonth = eventDateValues[0];
		eventDay = eventDateValues[1];
	} else {
		eventMonth = eventDateValues[1];
		eventDay = eventDateValues[0];
	}
	var assumeYear = false;
	var eventYear;
	if ( eventDateValues.length == 3 ) {
		eventYear = eventDateValues[2];
	}
	else {
		assumeYear = true;
		eventYear = nowYear;
	}
	
	var eventDateMillis;
	eventDateMillis = Date.parse( eventMonth + '/' + eventDay + '/' + eventYear );
	
	// If the difference in the times is negative, we assumed the wrong year.
	if ( ( assumeYear ) && ( eventDateMillis - nowMillis < 0 ) ) {
		var dateToParse = eventMonth + '/' + eventDay + '/' + ( parseInt( nowYear ) + 1 );
		eventDateMillis = Date.parse( dateToParse );
	}

	var daysLeft = Math.ceil( (eventDateMillis - nowMillis) / 86400000 );

	// If we're counting weekdays only, subtract some number of days from the count.
	if ( countWeekdaysOnly )
	{
		var weeksBetween = Math.floor( daysLeft / 7 );
		var startDay = now.getDay();
		var endDay = new Date( eventDateMillis ).getDay();
		var adjust = 5 + endDay - startDay;
		if ( startDay == endDay ) adjust = 0;
		else if ( startDay == 0 && endDay == 6 ) adjust = 5;
		else if ( startDay == 6 && endDay == 0 ) adjust = 0;
		else if ( endDay == 6 || endDay == 0 ) adjust = 5 - startDay;
		else if ( startDay == 0 || startDay == 6 ) {
			if ( daysLeft < 0 ) adjust = endDay;
			else adjust = endDay - 1;
		}
		else if ( endDay > startDay ) adjust = endDay - startDay;
		daysLeft = weeksBetween * 5 + adjust;
	}

	if ( daysLeft < 0 ) {
		document.getElementById( "daysLeftText" ).innerHTML = String( -daysLeft );
	}
	else {
		document.getElementById( "daysLeftText" ).innerHTML = String( daysLeft );
	}

	var daysUntilText = "";
	if ( countWeekdaysOnly ) {
		if ( daysLeft < 0 ) {
			if ( daysLeft == -1 ) {
				daysUntilText = getLocalizedString( "weekday since" );
			}
			else {
				daysUntilText = getLocalizedString( "weekdays since" );
			}
		}
		else {
			if ( daysLeft == 1 ) {
				daysUntilText = getLocalizedString( "weekday until" );
			}
			else {
				daysUntilText = getLocalizedString( "weekdays until" );
			}
		}
	}
	else {
		if ( daysLeft < 0 ) {
			if ( daysLeft == -1 ) {
				daysUntilText = getLocalizedString( "day since" );
			}
			else {
				daysUntilText = getLocalizedString( "days since" );
			}
		}
		else {
			if ( daysLeft == 1 ) {
				daysUntilText = getLocalizedString( "day until" );
			}
			else {
				daysUntilText = getLocalizedString( "days until" );
			}
		}
	}
	
	document.getElementById( "daysUntilText" ).innerHTML = daysUntilText;
	
	document.getElementById( "eventNameText" ).innerHTML = thisEventName;
}

function showAbout() {
	widget.openURL('http://www.c3images.com/dashboard/aboutCountdown.html?version=' + versionNumber);
}

function getLocalizedString( key ) {
	try {
		return localizedStrings[ key ];
	} catch (ex) {}

	return key;
}

function clickWeekdaysOnlyCheckbox() {
	var checkbox = document.getElementById( "countWeekdaysOnlyCheckbox" );
	checkbox.checked = ! checkbox.checked;
}

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
var flipShown = false;

function mousemove(event)
{
	if(!flipShown)
	{
		if(animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
				
		var starttime = (new Date).getTime() - 13;
				
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('i');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit(event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
				
		var starttime = (new Date).getTime() - 13;
				
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('i');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	T = limit_3(time-animation.starttime, 0, animation.duration);
		
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
		
	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

function enterflip(event)
{
	document.getElementById('iCircle').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('iCircle').style.display = 'none';
}
